#include <stdio.h>

#include "detect_comm.h"

int pcrc_detect_communication(detect_DIM* dad_x, detect_DIM* dad_y,
                              int* l, int* u, int* stride, int *a0, int *b0,
                              int* a1, int* b1, int *amount) {
  int devide(int s1,int s2);
  int no_communication_detect(detect_DIM *dad_x, detect_DIM *dad_y,
			      int l, int u, int s, int a0, int b0, int a1, int b1);
  void shift_amount(detect_DIM *dad_x, detect_DIM *dad_y,int p,int lx,int a0, 
		    int b0, int a1, int b1, int s, int tx, int ty, int *amount);
  
  int numProcs = dad_x->numProcs;
  int srcNumprocs = dad_y->numProcs;
  *amount = 0;
  

//   printf("Dad_x: code=%d p=%d lb=%d ub=%d stride=%d offset=%d\n",dad_x->distCode,dad_x->numProcs,dad_x->t_lb,dad_x->t_ub,dad_x->t_stride,dad_x->t_offset);

//   printf("Dad_y: code=%d p=%d lb=%d ub=%d stride=%d offset=%d\n",dad_y->distCode,dad_y->numProcs,dad_y->t_lb,dad_y->t_ub,dad_y->t_stride,dad_y->t_offset);

//   printf("l=%d u=%d stride=%d a0=%d b0=%d a1=%d b1=%d\n",*l,*u,*stride,*a0,*b0,*a1,*b1);
  


  if (numProcs != srcNumprocs) return 2;

  if (dad_x->distCode != dad_y->distCode) return 2;

  int tx = devide(dad_x->t_ub - dad_x->t_lb + 1, numProcs);
  int ty = devide(dad_y->t_ub - dad_y->t_lb + 1, numProcs);

  switch(dad_x->distCode) {
		case 0: 		// Collapse Distribution
				*amount = 0;
/*				*m = (float)srcPtr->dims[d].t_stride * (*a) /
							ptr->dims[d].t_stride;
				*c = (float)(srcPtr->dims[d].t_stride*(*a*
						(float)(1-ptr->dims[d].t_offset)/ptr->dims[d].t_stride
						+*b)+srcPtr->dims[d].t_offset-1);
*/
				
				return 0;
			break;
		case 1 : {		// BLOCK Distribution
			int t1 = dad_x->t_stride * (*a0) * ty;			// ax * a0 * ty
		    int t2 = dad_y->t_stride * (*a1) * tx;			// ay * a1 * tx
			if (t1 == t2) { 
				if (!no_communication_detect(dad_x,
						dad_y,*l,*u,*stride,*a0,*b0,*a1,*b1)) return 0;

				shift_amount(dad_x,dad_y,numProcs,*l,*a0,*b0,*a1,*b1,
								*stride,tx,ty,amount);
				return 1;
			}
			break;
			}
		case 2 : {		// CYCLIC Distribution
			int t = (dad_y->t_stride * (*a1) * (*stride)) % numProcs;
						//  ay * a1 * s (mod p)
			if (t == (dad_x->t_stride * (*a0) * (*stride) % numProcs)) {
						//  ax * a0 * s (mod p)
				shift_amount(dad_x,dad_y,numProcs,*l,*a0,*b0,*a1,*b1,
								*stride,tx,ty,amount);
				if (*amount == 0) return 0;
				else return 1;
			}
			break;
			}
	}

  return 2 ;
}

void shift_amount(detect_DIM *dad_x, detect_DIM *dad_y,int p,int lx,int a0, 
		int b0, int a1, int b1, int s, int tx, int ty, int *amount)
{
   int devide(int s1,int s2);
   int kx,ky_f,ky,kx_each,ky_each;

  switch(dad_x->distCode) {
		case 1 : 		// BLOCK Distribution
		    kx = dad_x->t_stride * (a0*lx+b0) + dad_x->t_offset;
	   	    ky_f = dad_y->t_stride * (a1*lx+b1) + dad_y->t_offset;

			kx = kx - dad_x->t_lb + 1;
			ky_f = ky_f - dad_y->t_lb + 1;

			ky = devide(kx*ty, tx);
			*amount = ky_f - ky;

/*			*u = (float)a*srcPtr->dims[d].t_stride/ptr->dims[d].t_stride;
		

			if (kx>=lower_index(ptr,d) && 
					kx<=lower_index(ptr,d)+ptr->dims[d].t_blockSize)
				kx_each = kx;
			else kx_each = kx + s*srcPtr->dims[d].t_stride * 
					devide(lower_index(ptr,d)-kx, s*srcPtr->dims[d].t_stride);

			ky_each = devide(kx_each * ty, tx);

			*v = (ky_each-lower_index(srcPtr,d)) - 
					(kx_each-lower_index(ptr,d))*(*u);
*/

			break;

		case 2 : 		// CYCLIC Distribution
		    kx = dad_x->t_stride * (a0*lx+b0) + dad_x->t_offset;
	   	    ky_f = dad_y->t_stride * (a1*lx+b1) + dad_y->t_offset;
			int px = (kx - dad_x->t_lb) % p;
			int py = (ky_f - dad_y->t_lb) % p;
			if (px == py) *amount = 0;
			else if (px > py && (ky_f/p) > (kx/p))  
						*amount = py + (p - px);
				else		*amount = py - px;

/*			*u = (float)a*srcPtr->dims[d].t_stride/ptr->dims[d].t_stride;
			*v = (float)((srcPtr->dims[d].t_stride*((a*(localCoord
				+ptr->dims[d].t_lb-ptr->dims[d].t_offset)/ptr->dims[d].t_stride)
				+b)+srcPtr->dims[d].t_offset-localCoord
				-srcPtr->dims[d].t_lb-(*amount))/p);
*/

			break;
  }

}

int devide(int s1,int s2)
{
	int s = s1 / s2;
	int q = s1 % s2;
	//	printf("%d/%d : %d,%d\n",s1,s2,s,q);
	if (q>0) s++;
	else if (q<0) s--;
	return s;
}

int no_communication_detect(detect_DIM *dad_x, detect_DIM *dad_y,
				int l, int u, int s, int a0, int b0, int a1, int b1)
{
	int sx = dad_x->t_stride * s * a0;
	int sy = dad_y->t_stride * s * a1;
  	int numProcs = dad_x->numProcs;
	int wx = devide(dad_x->t_ub - dad_x->t_lb + 1, numProcs); 
	int wy = devide(dad_y->t_ub - dad_y->t_lb + 1, numProcs);

	int l_tlbx[16], l_tubx[16], lkx[16], ukx[16];
	int l_tlby[16], l_tuby[16], lky[16], uky[16];
	int i;

	int ltx = dad_x->t_lb;
	int lty = dad_y->t_lb;

	for (i=0; i<=numProcs; i++) {
		l_tlbx[i] = ltx + i* wx;
		l_tubx[i] = ltx + (i+1) * wx -1;
		l_tlby[i] = lty + i * wy;
		l_tuby[i] = lty + (i+1) * wy -1;
	}

	int kx = dad_x->t_stride * (a0*l+b0) + dad_x->t_offset;
						// kx = ax*(a0*l+b)+bx
    int ky = dad_y->t_stride * (a1*l+b1) + dad_y->t_offset;
						// ky = ay*(a1*l+b)+by

	for (i=0; i<=numProcs; i++) {
		if (l_tlbx[i] > dad_x->t_stride * (a0*u+b0) + dad_x->t_offset ||
			l_tubx[i] < kx)
			lkx[i] = ltx -1;
		else if (l_tlbx[i] > kx)
				lkx[i] = kx + devide(l_tlbx[i] - kx, sx) * sx;
			 else lkx[i] = kx;
		
		if (l_tubx[i] < dad_x->t_stride * (a0*u+b0) + dad_x->t_offset)
			ukx[i] = kx + (l_tubx[i] - kx) / sx * sx;
		else ukx[i] = dad_x->t_stride * (a0*u+b0) + dad_x->t_offset;

		if (l_tlby[i]>dad_y->t_stride * (a1*u+b1) + dad_y->t_offset
					 || l_tuby[i] < ky)
			lky[i] = lty -1;
		else if (l_tlby[i] > ky)
				lky[i] = ky + devide(l_tlby[i] - ky, sy) * sy;
			 else lky[i] = ky;
		
		if (l_tuby[i]<dad_y->t_stride * (a1*u+b1) + dad_y->t_offset)
			uky[i] = ky + (l_tuby[i] - ky) / sy * sy;
		else uky[i]=dad_y->t_stride * (a1*u+b1) + dad_y->t_offset;

/*		*m = (float)a*dad_y->t_stride/dad_y->tride;		*/

		if (lkx[i] != ltx-1) {
			int ex = (ukx[i] - lkx[i]) / sx;
			int ey = (uky[i] - lky[i]) / sy;
/*			*c = (float)(lky[i] - l_tlby[i] - (float)((*m)*(lkx[i]-l_tlbx[i])));*/
			if (ex != ey) return 1;
		}
	}
	return 0;
}





