
#include <math.h>
#include <time.h>
#include <stdio.h>
#include <stdlib.h>

#include "generator.h"

extern void binding_1(int,int,int,int,int,int,int,int,int,int,int,int,
                      int,int,int,int,int,int,int,int,int,int,int);

extern void check_1(int,int,int,int,int,int,int,int,int,int,int,
                    int,int,int,int,int,int,int,int,int,int,int,int);

void main(int argc, char *argv[]) {

   int p=0,lx,ly,ux,uy,l,u,s,d1,d2,ax,ay,a1,a2,ltx,utx,lty,uty,bx,by,b1,b2;
   int MAX_STRIDE=4,load=LOAD,requirement,t,map,tx,ty,r,m,i;
   unsigned int seed;

   if (argc > 1) {
      requirement = atoi(argv[1]);
      if (argc > 2) {
         p = atoi(argv[2]);
         load = atoi(argv[3]);
         MAX_STRIDE = 1;
      };
/*     seed = atoi(argv[2]); */
   }
   else {
      printf("Please include requirement code in command line: \n");
      printf("1 -- no communication, 2 -- shift only \n");
      printf("3 -- remap only,       4 -- both shift and remap \n");
      return;
   }

   srand((unsigned int) time(NULL));

   if (p == 0) {
      t = rand() % 3;
      /*  p = pow(2,t+1); the number of processors: 2, 4, 8 */
      p = 2;
      while (t != 0) { p = p*2; t--;};
   }

   l = rand()%10; if(rand()%2) l=-l;
   u = rand()%10; if(rand()%2) u=-u;
   u = l + load + u;
   s = rand() % MAX_STRIDE + 1;

   switch (requirement) {
     case 1: /* no communication */
        d1 = d2 = rand()%2 + 1;
        if (d1==1) {  /* BLOCK distribute */
           ax = rand()%MAX_STRIDE + 1;
           ay = rand()%MAX_STRIDE + 1;
           a1 = a2 = rand()%MAX_STRIDE + 1;
           b1 = b2 = rand()%MAX_OFFSET; if(rand()%2) b1=b2=-b1;

           lx = l - rand()%MAX_DISPLACEMENT;
           ly = a1*l+b1 - rand()%MAX_DISPLACEMENT;
           
           m = (-ay*ly + (a1*l+b1)*ay+1)/(ay*a1) - l + 1;

           bx = rand()%MAX_OFFSET; if(rand()%2) bx = -bx;
           ltx = bx+1 -(max(-lx+1,m)+rand()%MAX_OFFSET)*ax; 

           /* map = ceiling((ax*l+bx)*ay*a1/ax); 
              where ax*l+bx > 0 is the positin of the first related element 
              of X in its template */
           map = (ax*l+bx-ltx+1)*ay*a1/ax;

           by = rand()%MAX_OFFSET; if(rand()%2) by = -by;
           lty = (a1*l+b1)*ay+by+1 - map;
           /* the above set up cannonical eq-ele condition */

           ux = u + rand()%MAX_DISPLACEMENT;
           uy = a1*u+b1 + rand()%MAX_DISPLACEMENT;
           /* the above set up within-array-bound condition */

           utx = ax*ux+bx; tx = utx-ltx+1;
           uty = ay*uy+by; ty = uty-lty+1;

           m = max(tx/ax,ty/(ay*a1)) + 1;

           tx = m*ax;  ty = m*(ay*a1);
           utx = tx + ltx - 1; 
           uty = ty + lty - 1;

           while (tx%p || ty%p) { /* make sure p divides both tx and ty */
             tx = tx*2; utx = tx + ltx -1;
             ty = ty*2; uty = ty + lty -1;
             /* also double the LOAD, so that elements
                are to be evenly distributed */
             u = u + load; load = u-l; 
             ux = u + rand()%MAX_DISPLACEMENT;
             uy = a1*u+b1 + rand()%MAX_DISPLACEMENT;
           }
           /* the above set up within-template-bound condition and
           shift-homomorphism condition */
        } 
        else {   /* CYCLIC distribution */
           a1 = a2 = rand()%MAX_STRIDE + 1;
           ay = rand()%MAX_STRIDE + 1;
           ax = ay*a1;
           /* the above set up a simplified shift-homomorphism condition 
              for CYCLIC distribution */
           b1 = b2 = rand()%MAX_OFFSET; if (rand()%2) b1 = b2 = -b1;

           lx = l - rand()%MAX_DISPLACEMENT;
           ly = a1*l+b1 - rand()%MAX_DISPLACEMENT;

           t = ((ax*l-ax*lx)/p + 1)*p - ax*l;   /* bx-ltx */

           bx = rand()%MAX_OFFSET; if(rand()%2) bx = -bx;
           ltx = bx - t; 

           t = ((ay*(a1*l+b1)-ay*ly)/p + 1)*p - ay*(a1*l+b1);   /* by-lty */

           by = rand()%MAX_OFFSET; if(rand()%2) by = -by;
           lty = by - t; 

           ux = u + rand()%MAX_DISPLACEMENT;
           uy = a1*u+b1 + rand()%MAX_DISPLACEMENT;
           /* the above set up within-array-bound condition */

           utx = ax*ux+bx + rand()%MAX_OFFSET;
           uty = ay*uy+by + rand()%MAX_OFFSET;

        }
        break;
     case 2: /* shift only */
        d1 = d2 = rand()%2 + 1;
        if (d1==1) {  /* BLOCK distribute */
           ax = rand()%MAX_STRIDE + 1;
           ay = rand()%MAX_STRIDE + 1;
           a1 = a2 = rand()%MAX_STRIDE + 1;
           /* the above set up ratio for shift-homomorphism condition */

           b1 = rand()%MAX_OFFSET;
           b2 = rand()%MAX_OFFSET;

           lx = l - rand()%MAX_DISPLACEMENT; 
           ly = a1*l+min(b1,b2) - rand()%MAX_DISPLACEMENT;

           bx = rand()%MAX_OFFSET; if (rand()%2) bx = -bx;
           by = rand()%MAX_OFFSET; if (rand()%2) by = -by;

           ux = u + rand()%MAX_DISPLACEMENT;
           uy = a1*u+max(b1,b2) + rand()%MAX_DISPLACEMENT;
           /* the above set up within-array-bound condition */

           ltx = (ax*lx+bx) - rand()%MAX_OFFSET;
           lty = (ay*ly+by) - rand()%MAX_OFFSET;
           utx = ax*ux+bx; tx = utx-ltx+1;
           uty = ay*uy+by; ty = uty-lty+1;

           if (ax/(ay*a1) > tx/ty) {
              t = (ty%(ay*a1))?(ty/(ay*a1)+1)*ay*a1:ty;
              /* t is the least number > ty and a multiple of ay*a1 */
              uty = uty + (t-ty); ty = uty-lty+1;
              tx = ty*ax/(ay*a1);
              utx = tx + ltx - 1;
           }
           else {
              t = (tx%ax)?(tx/ax+1)*ax:tx;
              utx = utx + (t-tx); tx = utx-ltx+1;
              ty = tx*ay*a1/ax;
              uty = ty + lty -1;
           }  
           while (tx%p || ty%p) { /* make sure p divides both tx and ty */
             tx = tx*2; utx = tx + ltx -1;
             ty = ty*2; uty = ty + lty -1;
             /* also double the LOAD, so that elements
                are to be evenly distributed */
             u = u + load; load = u-l;
             ux = u + rand()%MAX_DISPLACEMENT;
             uy = a1*u+b1 + rand()%MAX_DISPLACEMENT;
           }
           /* the above set up within-template-bound condition and
           shift-homomorphism condition */
        } 
        else {   /* CYCLIC distribution */
           a1 = a2 = rand()%MAX_STRIDE + 1;
           ay = rand()%MAX_STRIDE + 1;
           ax = ay*a1;
           /* the above set up a simplified shift-homomorphism condition 
              for CYCLIC distribution */

           b1 = rand()%MAX_OFFSET;
           b2 = rand()%MAX_OFFSET;

           lx = l - rand()%MAX_DISPLACEMENT;
           ly = a1*l+min(b1,b2) - rand()%MAX_DISPLACEMENT;
            
           bx = rand()%MAX_OFFSET; if (rand()%2) bx = -bx;
           by = rand()%MAX_OFFSET; if (rand()%2) by = -by;
          
           ux = u + rand()%MAX_DISPLACEMENT;
           uy = a1*u+max(b1,b2) + rand()%MAX_DISPLACEMENT;
           /* the above set up within-array-bound condition */

           ltx = (ax*lx+bx) - rand()%MAX_OFFSET;
           lty = (ay*ly+by) - rand()%MAX_OFFSET;

           utx = ax*ux+bx + rand()%MAX_DISPLACEMENT;
           uty = ay*uy+by + rand()%MAX_DISPLACEMENT; 
        }
        break;
     case 3: /* remap only */
        d1 = rand()%2 + 1;
        d2 = rand()%2 + 1;

        a1 = rand()%MAX_STRIDE + 1;
        a2 = rand()%MAX_STRIDE + 1;

        b1 = rand()%MAX_OFFSET; 
        b2 = rand()%MAX_OFFSET; 

        lx = l - rand()%MAX_DISPLACEMENT;
        ly = min(a1*l+b1,a2*l+b2) - rand()%MAX_DISPLACEMENT;

        ux = u + rand()%MAX_DISPLACEMENT;
        uy = max(a1*u+b1,a2*u+b2) + rand()%MAX_DISPLACEMENT;
        /* the above set up within-array-bound condition */

        ax = rand()%MAX_STRIDE + 1;
        bx = rand()%MAX_STRIDE + 1;

        ay = rand()%MAX_STRIDE + 1;
        by = rand()%MAX_STRIDE + 1;

        ltx = (ax*lx+bx) - rand()%MAX_OFFSET;
        lty = (ay*ly+by) - rand()%MAX_OFFSET;

        utx = ax*ux+bx + rand()%MAX_DISPLACEMENT;
        uty = ay*uy+by + rand()%MAX_DISPLACEMENT; 
        /* the above set up within-template-bound condition */
        break;
     case 4: /* first term shift, second term remap */
        d1 = d2 = rand()%2 + 1;
        if (d1==1) {  /* BLOCK distribute */
           ax = rand()%MAX_OFFSET + 1;
           ay = rand()%MAX_OFFSET + 1;
           a1 = rand()%MAX_OFFSET + 1;
           /* the above set up ratio for shift-homomorphism condition */
           a2 = rand()%MAX_OFFSET + 1;
           if (a2 == a1) a2 = a1 + 1;
           /* make it almost impossible for second term to be 'shift' */

           b1 = rand()%MAX_OFFSET;
           b2 = rand()%MAX_OFFSET;

           lx = l - rand()%MAX_DISPLACEMENT; 
           ly = min(a1,a2)*l+min(b1,b2) - rand()%MAX_DISPLACEMENT;

           bx = rand()%MAX_OFFSET; if (rand()%2) bx = -bx;
           by = rand()%MAX_OFFSET; if (rand()%2) by = -by;

           ux = u + rand()%MAX_DISPLACEMENT;
           uy = max(a1,a2)*u+max(b1,b2) + rand()%MAX_DISPLACEMENT;
           /* the above set up within-array-bound condition */

           ltx = (ax*lx+bx) - rand()%MAX_OFFSET;
           lty = (ay*ly+by) - rand()%MAX_OFFSET;
           utx = ax*ux+bx; tx = utx-ltx+1;
           uty = ay*uy+by; ty = uty-lty+1;

           /* the above set up within-template-bound condition */

           if (ax/(ay*a1) > tx/ty) {
              t = (ty%(ay*a1))?(ty/(ay*a1)+1)*ay*a1:ty;
              uty = uty + (t-ty); ty = uty-lty+1;
              tx = ty*ax/(ay*a1);
              utx = tx + ltx - 1;
           }
           else {
              t = (tx%ax)?(tx/ax+1)*ax:tx;
              utx = utx + (t-tx); tx = utx-ltx+1;
              ty = tx*ay*a1/ax;
              uty = ty + lty - 1;
           };
           while (tx%p || ty%p) { /* make sure p divides both tx and ty */
             tx = tx*2; utx = tx + ltx -1;
             ty = ty*2; uty = ty + lty -1;
             /* also double the LOAD, so that elements
                are to be evenly distributed */
             u = u + load; load = u-l;
             ux = u + rand()%MAX_DISPLACEMENT;
             uy = a1*u+b1 + rand()%MAX_DISPLACEMENT;
           }
           /* the above set up within-template-bound condition and
           shift-homomorphism condition */
        } 
        else {   /* CYCLIC distribution */
           a1 = rand()%MAX_STRIDE + 1;
           a2 = rand()%MAX_STRIDE + 1;
           if (a2 == a1) a2 = a1 + 1;
           /* make it almost impossible for second term to be 'shift' */
           ay = rand()%MAX_STRIDE + 1;
           ax = ay*a1;
           /* the above set up a simplified shift-homomorphism condition 
              for CYCLIC distribution */

           b1 = rand()%MAX_OFFSET;
           b2 = rand()%MAX_OFFSET;

           lx = l - rand()%MAX_DISPLACEMENT;
           ly = min(a1,a2)*l+min(b1,b2) - rand()%MAX_DISPLACEMENT;
            
           bx = rand()%MAX_OFFSET; if (rand()%2) bx = -bx;
           by = rand()%MAX_OFFSET; if (rand()%2) by = -by;
          
           ux = u + rand()%MAX_DISPLACEMENT;
           uy = max(a1,a2)*u+max(b1,b2) + rand()%MAX_DISPLACEMENT;
           /* the above set up within-array-bound condition */

           ltx = (ax*lx+bx) - rand()%MAX_OFFSET;
           lty = (ay*ly+by) - rand()%MAX_OFFSET;

           utx = ax*ux+bx + rand()%MAX_DISPLACEMENT;
           uty = ay*uy+by + rand()%MAX_DISPLACEMENT; 
        }
        break;
     default:
        printf("No such a case \n");
  }

   check_1(requirement,p,lx,ly,ux,uy,l,u,s,d1,d2,ax,ay,a1,a2,
           ltx,utx,lty,uty,bx,by,b1,b2);

   binding_1(requirement,p,lx,ly,ux,uy,l,u,s,d1,d2,ax,ay,a1,a2,
                   ltx,utx,lty,uty,bx,by,b1,b2);
   printf("!  The parameters in order: \n");
   printf("!  p,lx,ly,ux,uy,l,u,s,d1,d2,ax,ay,a1,a2,ltx,utx,lty,uty,bx,by,b1,b2 \n");
   printf("!  %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d \n",
         p,lx,ly,ux,uy,l,u,s,d1,d2,ax,ay,a1,a2,ltx,utx,lty,uty,bx,by,b1,b2);

  printf("\n\n!  Some selected output values for X(i)=%d,%d:\n",l,l+39);
  t = 0;
  printf("!  ");
  for (i=l;i<l+40;i=i++) {
     printf("%6d",(a1*i+b1) + (a2*i+b2));
     t++; if (t == 10) {t = 0; printf("\n!  ");}
  }
  printf("\n");
}

